package il.ac.tau.cs.sw1.sortedset.lazy;

import il.ac.tau.cs.sw1.sortedset.SortedSet;

/**
 * This class provides a skeletal lazy implementation of the SortedSet interface
 */
public abstract class BinaryOpSortedSet<T extends Comparable<T>> implements
		SortedSet<T> {
	protected SortedSet<T> setA, setB;

	/**
	 * Constructs a new BinaryOpSortedSet from two preexisting sorted sets
	 * 
	 * @param setA
	 *            - the first set
	 * @param setB
	 *            - the second set
	 */
	public BinaryOpSortedSet(SortedSet<T> setA, SortedSet<T> setB) {
		if (setA == null || setB == null) {
			throw new IllegalArgumentException();
		}
		this.setA = setA;
		this.setB = setB;
	}

	/**
	 * Return the maximum element in this set.
	 * 
	 * @return the maximum element in this set.
	 */
	@Override
	public final T getMaximum() {
		// TODO: Implement the method
	}

	/**
	 * Return the minimum element in this set.
	 * 
	 * @return the minimum element in this set.
	 */
	@Override
	public final T getMinimum() {
		// TODO: Implement the method
	}

	/**
	 * Return true iff the set is empty.
	 * 
	 * @return true iff the set is empty
	 */
	@Override
	public final boolean isEmpty() {
		// TODO: Implement the method
	}

	/**
	 * Return the size of the set. the size is computed only once, and is cached
	 * for later use
	 * 
	 * @return the size of this set.
	 */
	@Override
	public final int size() {
		// TODO: Implement the method
	}

	// TODO: Add more code as you see fit
}
